"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _canUseDOM = _interopRequireDefault(require("./utils/canUseDOM"));

var _excluded = ["code", "onChange", "editorConfig"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultEditorConfig = {
  mode: 'jsx',
  tabSize: 2,
  theme: 'default'
};

var CodeEditor = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var code = props.code,
      onChange = props.onChange,
      editorConfig = props.editorConfig,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var textareaRef = (0, _react.useRef)(null);
  var editor = (0, _react.useRef)(null);
  var handleChange = (0, _react.useCallback)(function () {
    var _editor$current;

    onChange === null || onChange === void 0 ? void 0 : onChange((_editor$current = editor.current) === null || _editor$current === void 0 ? void 0 : _editor$current.getValue());
  }, [onChange]);
  (0, _react.useEffect)(function () {
    // https://github.com/JedWatson/react-codemirror/issues/77#issuecomment-279465181
    if (textareaRef.current && _canUseDOM["default"]) {
      Promise.resolve().then(function () {
        return _interopRequireWildcard(require('codemirror/mode/javascript/javascript'));
      });
      Promise.resolve().then(function () {
        return _interopRequireWildcard(require('codemirror/mode/jsx/jsx'));
      });
      Promise.resolve().then(function () {
        return _interopRequireWildcard(require('codemirror/addon/runmode/runmode'));
      });
      Promise.resolve().then(function () {
        return _interopRequireWildcard(require('codemirror'));
      }).then(function (module) {
        if (textareaRef.current) {
          editor.current = module.fromTextArea(textareaRef.current, Object.assign(defaultEditorConfig, editorConfig));
          editor.current.on('change', handleChange);
        }
      });
    }
  }, []);
  (0, _react.useEffect)(function () {
    if (code) {
      var _editor$current2;

      (_editor$current2 = editor.current) === null || _editor$current2 === void 0 ? void 0 : _editor$current2.setValue(code);
    }
  }, [code]);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    ref: ref
  }, rest), /*#__PURE__*/_react["default"].createElement("textarea", {
    ref: textareaRef,
    defaultValue: code === null || code === void 0 ? void 0 : code.trim()
  }));
});

var _default = CodeEditor;
exports["default"] = _default;