"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = parseHTML;

var _parseDom = _interopRequireDefault(require("./parseDom"));

function text(element) {
  return element.textContent || element.innerText;
}

function parseHTML(source) {
  var _source$match, _source$match2;

  if (!source) {
    return null;
  }

  var exampleCode = source.match(/<!-+\ ?start-code\ ?-+>([\s\S]+)<!-+\ ?end-code\ ?-+>/gi);

  if (!exampleCode) {
    return {
      beforeHTML: source
    };
  }

  var code = text((0, _parseDom["default"])(exampleCode.join('').replace(/\n+/, '')));
  var beforeHTML = (_source$match = source.match(/([\s\S]+)<!-+\ ?start-code\ ?-+>/gi)) === null || _source$match === void 0 ? void 0 : _source$match.join('');
  var afterHTML = (_source$match2 = source.match(/<!-+\ ?end-code\ ?-+>([\s\S]+)/gi)) === null || _source$match2 === void 0 ? void 0 : _source$match2.join('');
  return {
    code: code,
    beforeHTML: beforeHTML,
    afterHTML: afterHTML
  };
}