import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["code", "onChange", "editorConfig"];
import React, { useCallback } from 'react';
import { useRef } from 'react';
import { useEffect } from 'react';
import canUseDOM from './utils/canUseDOM';
var defaultEditorConfig = {
  mode: 'jsx',
  tabSize: 2,
  theme: 'default'
};
var CodeEditor = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var code = props.code,
      onChange = props.onChange,
      editorConfig = props.editorConfig,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  var textareaRef = useRef(null);
  var editor = useRef(null);
  var handleChange = useCallback(function () {
    var _editor$current;

    onChange === null || onChange === void 0 ? void 0 : onChange((_editor$current = editor.current) === null || _editor$current === void 0 ? void 0 : _editor$current.getValue());
  }, [onChange]);
  useEffect(function () {
    // https://github.com/JedWatson/react-codemirror/issues/77#issuecomment-279465181
    if (textareaRef.current && canUseDOM) {
      import('codemirror/mode/javascript/javascript');
      import('codemirror/mode/jsx/jsx');
      import('codemirror/addon/runmode/runmode');
      import('codemirror').then(function (module) {
        if (textareaRef.current) {
          editor.current = module.fromTextArea(textareaRef.current, Object.assign(defaultEditorConfig, editorConfig));
          editor.current.on('change', handleChange);
        }
      });
    }
  }, []);
  useEffect(function () {
    if (code) {
      var _editor$current2;

      (_editor$current2 = editor.current) === null || _editor$current2 === void 0 ? void 0 : _editor$current2.setValue(code);
    }
  }, [code]);
  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, rest), /*#__PURE__*/React.createElement("textarea", {
    ref: textareaRef,
    defaultValue: code === null || code === void 0 ? void 0 : code.trim()
  }));
});
export default CodeEditor;